package org.example.componentschema;

import java.io.File;
import java.io.IOException;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

public class ComponentServiceUtil {

	public static void convertObjectToXML(System sys, String xmlFilePath) {
		try {
			File xmlFile = new File(xmlFilePath);
			if (xmlFile.exists()) {
				xmlFile.delete();
			}
			if (!xmlFile.getParentFile().exists()) {
				xmlFile.mkdirs();
			}
			JAXBContext jaxbContext = JAXBContext.newInstance(System.class);
			Marshaller jaxbMarshaller = jaxbContext.createMarshaller();

			jaxbMarshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);

			jaxbMarshaller.marshal(sys, xmlFile);
			jaxbMarshaller.marshal(sys, java.lang.System.out);

		} catch (JAXBException e) {
			e.printStackTrace();
		}
	}

	public static System convertXMLToObject(String xmlFilePath) {
		System sys = null;
		try {
			File xmlFile = new File(xmlFilePath);
			JAXBContext jaxbContext = JAXBContext.newInstance(System.class);
			Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
			sys = (System) jaxbUnmarshaller.unmarshal(xmlFile);
		} catch (JAXBException e) {
			e.printStackTrace();
		}
		return sys;
	}

	public static void main(String[] args) {
		System sys = convertXMLToObject(
				"C:\\repos\\mbeddr-lms\\code\\api\\applications\\framework\\ESDAPICoreServices\\testXmlFiles\\componentSchema.xml");
		for (Component comp : sys.components) {
			java.lang.System.out.println(comp.name);
			java.lang.System.out.println(comp.inportName);
			java.lang.System.out.println(comp.outPortName);
			if (comp.subComponents != null) {
				for (SubComponent subComp : comp.subComponents) {
					java.lang.System.out.println(subComp.name);
					java.lang.System.out.println(subComp.inportName);
					java.lang.System.out.println(subComp.outPortName);
				}
			}
		}
		for (InPort inP : sys.inPorts) {
			java.lang.System.out.println(inP.name);
			java.lang.System.out.println(inP.value);
		}
		for (OutPort ouP : sys.outPorts) {
			java.lang.System.out.println(ouP.name);
			java.lang.System.out.println(ouP.value);
		}
	}
}
